#include <iostream>
#include <cstdlib> 
using namespace std;

#include <Inventor/SoDB.h>
#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoNormal.h>
#include <Inventor/nodes/SoNormalBinding.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoQuadMesh.h>
#include <Inventor/nodes/SoShapeHints.h>
#include <Inventor/nodes/SoLightModel.h>	


const int xmax = 500, ymax = 500;
const int  vertex = (xmax)*(ymax)*4;
const int  faces = (xmax*ymax);
// Positions of all of the vertexPositions:
static float vertexPositions[vertex][3];
static int32_t numvertexPositions[faces];
// Colors for the 12 faces
static float colors[faces][3];
// Normals for each polygon:
static float norms[1][3] = {.0f, .0f, 1.0f};
void creaVertexIndicesColores(){
	cout<<"creaVertexIndicesColores"<<endl;
	//primero crea los  4 vertexPositions
	int zz = 0;
	for(int i=0; i < ymax+1;++i){
		for(int j=0; j < xmax+1;++j){
			vertexPositions[zz][0] = float(j);
			vertexPositions[zz][1] = float(i);
			vertexPositions[zz][2] = 0.0f;
			//cout<<"vertex["<<zz<<"] = ("<<vertexPositions[zz][0]<<", "<<vertexPositions[zz][1]<<", "<<vertexPositions[zz][2]<<"}"<<endl;
			zz += 1;
		}
	}
	//luego crea las caras
	int32_t cara = 0;
	for(int i=0;i<(xmax*ymax);++i){
		numvertexPositions[i] = 4;
	}
	/*//luego las normales
	for(int i=0;i<(xmax*ymax);++i){
		norms[i][0] = 0.0f;
		norms[i][1] = 0.0f;
		norms[i][2] = 1.0f;
	}*/
	//y por ultimo los colores
	int jk = 0;
	srand(0); // seed random number generator by i	
	for(int i = 0; i<faces;++i){
		jk = rand(); 
		if(jk%9 == 0){
			colors[i][0]= .7f;
			colors[i][1]= .0f; 
			colors[i][2]= .7f;
		}
		else if(jk%9 == 1){
			colors[i][0]= 1.0f;
			colors[i][1]= .0f; 
			colors[i][2]= .0f;
		}
		else if(jk%9 == 2){
			colors[i][0]= .0f;
			colors[i][1]= .0f; 
			colors[i][2]= 1.0f;
		}
		else if(jk%9 == 3){
			colors[i][0]= .0f;
			colors[i][1]= .7f; 
			colors[i][2]= .7f;
		}
		else if(jk%9 == 4){
			colors[i][0]= .0f;
			colors[i][1]= 1.0f; 
			colors[i][2]= .0f;
		}
		else if(jk%9 == 5){
			colors[i][0]= .7f;
			colors[i][1]= .7f; 
			colors[i][2]= .0f;
		}
		else if(jk%9 == 6){
			colors[i][0]= .7f;
			colors[i][1]= .0f; 
			colors[i][2]= .7f;
		} 
		else if(jk%9 == 7){
			colors[i][0]= .0f;
			colors[i][1]= .0f; 
			colors[i][2]= 1.0f;
		}
		else if(jk%9 == 8){
			colors[i][0]= .0f;
			colors[i][1]= .0f; 
			colors[i][2]= 1.0f;
		}
		else if(jk%9 == 9){
			colors[i][0]= .7f;
			colors[i][1]= .0f; 
			colors[i][2]= .7f;
			jk = -1;
		}
		jk +=1;
	}
}
// Routine to create a scene graph representing an arch.
SoSeparator * makeArch()
{
	creaVertexIndicesColores();
	SoSeparator *result = new SoSeparator;
	result->ref();
	
	// A shape hints tells the ordering of polygons. 
	SoShapeHints *myHints = new SoShapeHints;
	myHints->shapeType = SoShapeHints::SOLID;
	result->addChild(myHints);
	
	/*//algo no le gusta de esto de la luz--------
	//define ligth
	SoLightModel *myLigth = new SoLightModel;
	myLigth->model = SoLightModel::BASE_COLOR;
	result->addChild(myLigth);
	//--------------------------------------------*/



	// Define the normals used:
	SoNormal *myNormals = new SoNormal;
	myNormals->vector.setValues(0, 1, norms);
	result->addChild(myNormals);
	SoNormalBinding *myNormalBinding = new SoNormalBinding;
	myNormalBinding->value = SoNormalBinding::OVERALL;
	result->addChild(myNormalBinding);
	
	// Define colors for the strips
	SoMaterial *myMaterials = new SoMaterial;
	myMaterials->diffuseColor.setValues(0, faces, colors);
	result->addChild(myMaterials);
	SoMaterialBinding *myMaterialBinding = new SoMaterialBinding;
	myMaterialBinding->value = SoMaterialBinding::PER_FACE;
	result->addChild(myMaterialBinding);
	
	// Define coordinates for vertexPositions
	SoCoordinate3 *myCoords = new SoCoordinate3;
	myCoords->point.setValues(0, vertex, vertexPositions);
	result->addChild(myCoords);

	// Define the QuadMesh.
	SoQuadMesh *myQuadMesh = new SoQuadMesh;
	myQuadMesh->verticesPerRow = xmax+1;
		
	myQuadMesh->verticesPerColumn = ymax+1;
	result->addChild(myQuadMesh);

	result->unrefNoDelete();
	return result;
}
int main(int argc, char **argv)
{
	// Initialize Inventor and Xt
	HWND myWindow  = SoWin::init(argc, argv, argv[0]);
	if (myWindow == NULL) 
		exit(1);

	SoSeparator *root = makeArch();
	root->ref();
	
	SoWinExaminerViewer *myViewer = new SoWinExaminerViewer(myWindow);
	myViewer->setSceneGraph(root);
	myViewer->setTitle("GraphWorld");
	myViewer->setHeadlight(TRUE);
	myViewer->show();

	SoWin::show(myWindow);
	SoWin::mainLoop();
}