#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>

#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <Inventor/Win/viewers/SoWinExaminerViewer.h>

#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/SbName.h>

#include <iostream>

using namespace std;

int main(int argc, char **argv)
{
	// Initialize Inventor and SoWin
	HWND myWindow  = SoWin::init(argc, argv, argv[0]);
	if (myWindow == NULL) exit(1);

	SoSeparator *automaton = new SoSeparator;
	automaton->ref();

	SoOrthographicCamera *orthoViewAll = new SoOrthographicCamera;
	automaton->addChild(orthoViewAll);
	// Create a light
	automaton->addChild(new SoDirectionalLight);

	SoCube *celda = new SoCube;
	celda->width = 1.0f;
	celda->height = 1.0f;
	celda->depth = 1.0f;
				

	float xx = 0.0;
	float yy = 0.0;
	int maxx = 100;
	int maxy = 200;
	for(int i = 0; i< maxx;++i){
		for(int j = 0; j < maxy; ++j){
			SoTransform *calfTransform = new SoTransform;
			SoSeparator *automata = new SoSeparator;
			SoBaseColor * col = new SoBaseColor;

			automata->setName( ((""+i) +j) );
			col->setName(( (("color"+i) +j) ));
			calfTransform->translation.setValue(xx, yy, 0);
			col->rgb = SbColor(0.0f+(i*0.1), 0.0f+(j*0.1), 0.0f);
			automata->addChild(calfTransform);
			automata->addChild(col);
			automata->addChild(celda);
			xx = xx + 1.1f;
			automaton->addChild(automata);

		}
			xx = 0.0f;
			yy = yy + 1.1f;
	}
	
	
	// Set up viewer:
	SoWinRenderArea *myViewer = new SoWinRenderArea(myWindow);
	
	// Establish camera positions. 
	// First do a viewAll() on all three cameras.  
	// Then modify the position of the off-center camera.
	SbViewportRegion myRegion(myViewer->getSize());
	orthoViewAll->viewAll(automaton, myRegion);
	
	myViewer->setSceneGraph(automaton);

	//SoWinExaminerViewer *myViewer = new SoWinExaminerViewer(myWindow);
	myViewer->setSceneGraph(automaton);
	myViewer->setTitle("Examiner Viewer");
	myViewer->show();


	SoWin::show(myWindow);
	SoWin::mainLoop();
}