#ifndef Neighborhood_h
#define Neighborhood_h

#include <vector>

class Neighborhood{
    
    protected:
    //this is the container of neighbor's positions(vectors) 
    std::vector< std::vector<int> > neighborsPositions; 
    
    //this vector will be used for create a neighbor position
    //and push in to the conatiner (neighborsPositions) 
     std::vector<int> neighborCoordinates; 
    
    /*/represents how far we are gonna take neigbor's 
    //default value is one 
    //for example: if is a TowerNeighborhood of size one,
    //we have the four cardinal directions, every one
    //represesented for !one! neighbor 
    //so every cardinal direction is represented by a size
    //of neigbors*/
    int size;
    
    public:
     
    Neighborhood(int size = 1): size(size){} 

	// The copy-constructor:
    Neighborhood(const Neighborhood& n): size(n.size){}
	
	//overrite the = operator to avoid problems when you
    //forget inizialize whit the contructor   
    Neighborhood& operator=(const Neighborhood& n) {
        size = n.size;
        return *this;
    }   
    
    //the destructor is virtual so if you want to clean
    //all resources created in the derived class, but
    //you only have a pointer to the base class (Polymorphism)
    //everithing works fine 
    virtual ~Neighborhood(){ }
    
    //------get methods-----------------------------
    
    std::vector< std::vector<int> > getNeighborhood(){return neighborsPositions;}
    
    int getSize(){return size;}        
    
    //------end get methods-------------------------         
    void setSize(int s){size = s;}
        
    
    //this is the main method in the class
    virtual void calculateNeighborhood(const std::vector<int> position) {};          

};

#endif
