#ifndef Dimension_h
#define Dimension_h

class Dimension {
    /*This type of objects represent one dimension
    (an axe in the "picture"), and can be normalized, 
    like a ring, or with bounds*/

    //the size or numbers of coordinates in this axe
    int maxLimit;
    //is a ring (true) or a strand (with bounds)(false)
    bool normalized;
    
    public:
    
    //the constructor, creates a object, with a given 
    //size (100 default) and type of bounds (default with bounds)
    Dimension(int size=100, bool normalized=false): maxLimit(size), normalized(normalized){}
    
    // The copy-constructor:
    Dimension(const Dimension& d): maxLimit(d.maxLimit), normalized(d.normalized){}
    
	//overrite the = operator to avoid problems when you
    //forget inizialize whit the contructor   
    Dimension& operator=(const Dimension& d) {
        maxLimit = d.maxLimit;
        normalized = d.normalized;
        return *this;
    }   
    
	// the destructor
    ~Dimension(){}    
                
    //get set methods --------------------------
    inline int getSize(){return maxLimit;}
    inline void setSize(int dsize){maxLimit = dsize;}
    inline bool getNormalized(){return normalized;}  
    inline void setNormalized(bool normal){normalized = normal;}
    //---------------------------------------
    
    /*this method is to know if a coordinate
    is outside of bounds*/ 
    inline bool isOutOfBounds(int coordinate){    
    
		//if the dimension is normalized there is not
		//bounds    
		if(normalized)
			return false;
		//if not normalized
		else{
		//and the cordinate is to big or to small
		//is outside of bounds
			if( (0 <= coordinate)&&(coordinate < maxLimit) )
                return false;                               
			else
                return true;
		}
	}//---------isOutOfBounds(int coordinate)------------------
   
    /*this method is to return the position, in the dimension
     * only has sence to call it if the dim is normalized   */
    inline int getPos(int coordinate){
		if(normalized){
			//if the coordinate is not in the bounds
			if(! ((0<= coordinate) && (coordinate < maxLimit)) ){
				if(0 > coordinate){
					/*if the coordinate is negative move
					one time the dimencion to the left 
					and try again the function*/
					coordinate = getPos(coordinate += maxLimit);
					return coordinate; 
				}                
				else{                
					/*if the coordinate is bigger than the
					limits move one time the dimencion to 
					the rigth and try again the function*/
					coordinate = getPos(coordinate -= maxLimit);                       
					return coordinate;                     
				}
			}    
			else {//if the coordinate is in betwen boundary's
				return coordinate;
			}                
		}
		else{ //not normalized
			return coordinate;
		}
	}//-------------------getPos(int coordinate)----------------      
};
#endif
