#ifndef Map_h
#define Map_h

#include <vector>

#include "Topology.h"
#include "Neighborhood.h"
#include "TowerNeighborhood.h"


class Map {
    
    //the map have a pointer to a topology object
    Topology *topology;
    
    //and a Neighborhood element to make the soup :-)
    Neighborhood *neighborhood;
    
    //the creation of the edges of the net is keep in
    //a container
    std::vector< std::vector<int> > edge; 
    
    //need a copy vector to calculaions in setEdge method and
    //dont whant to create a new one every time the method is called
    std::vector< std::vector<int> > copyEdge;
    
    public:
        
        //constructor
        Map(Topology *top, Neighborhood *hood): topology(top), neighborhood(hood){}
        // The copy-constructor:
        Map(const Map &m): topology(m.topology), neighborhood(m.neighborhood){}   
        
		//overrite the = operator to avoid problems when you
		//forget inizialize whit the contructor   
		Map& operator=(const Map& m) {
			topology = m.topology;
			neighborhood = m.neighborhood;
			return *this;
		}   

        //-------get set methods------------------------------
        void setTopology(Topology *top){topology = top;} 
        
        void setNeighborhood(Neighborhood *hood){neighborhood = hood;}
        
		void setNormalizedDimencion(int dim){topology->setDimensionNormalized(dim);}
		
		void setDimencionSize(int dim, int dimSize){topology->setDimensionSize(dim, dimSize);}

		void setNeighborhoodSize(int size){neighborhood->setSize(size);}

        std::vector < std::vector<int> > getEdge(){return edge;}       
        
		/*this is the main method of the class, in this method
        the Topology and Neighborhood objects are mixed
        to creata the edges of the net, the cellular automata
        net*/        
		std::vector <std::vector<int> > setEdge(const std::vector<int> position)
        {
    
			edge.clear();
			neighborhood->calculateNeighborhood(position);
			copyEdge = neighborhood->getNeighborhood();
			//for all neigbors check if they exist in the actual topology
			for(unsigned int i = 0; i < copyEdge.size(); ++i){
				if( !(topology->isOutOfBounds(copyEdge[i])) )
					edge.push_back( topology->getPos(copyEdge[i]) );    
			}	  
     
			return edge; 

		}//-------------setEdge(const vector<int> position)----

		//-------end get set methods--------------------------
        
};
#endif
