#ifndef TowerNeighborhood_h
#define TowerNeighborhood_h

//read first Neighborhood.h class definition!!!! 
#include "Neighborhood.h"

class TowerNeighborhood : public Neighborhood{
    
    
    public:
        //the constructor, creates a object, with a given 
        //dimension
        TowerNeighborhood(int size = 1): Neighborhood(size){}
    
        // The copy-constructor:
        TowerNeighborhood(const TowerNeighborhood& t): Neighborhood(t.size){}
        
		//overrite the = operator to avoid problems when you
		//forget inizialize whit the contructor   
		TowerNeighborhood& operator=(const TowerNeighborhood& t) {
			size = t.size;
			return *this;
		}   
		//the destructor
        ~TowerNeighborhood(){
			neighborsPositions.clear();; 
			neighborCoordinates.clear();; 
		}
        
        //this is the main method in the class
        void calculateNeighborhood(const std::vector<int> position){
    
			//first empty the position vect and the neighborsPositions vect
			neighborCoordinates.clear();
			neighborsPositions.clear();
    
			// to make the calculations easy start with  a copy of 
			//the Coordinates vector, this copy is gone to be modify
			//and push_back in the neighborsPositions vector, without 
			//modify the given position vector need for extra calculations
			neighborCoordinates = position;
    
			//make the calculations for each dimmension fo 
			//the neighborCoordinatesvector, is size
			for(unsigned int i = 0; i < neighborCoordinates.size() ; ++i){
        
				//make a number of neigbor in one direccion
				//this number depends on the size of the class         
				for(int j = 0; j < size; ++j ){
					neighborCoordinates[i] = neighborCoordinates[i] + 1;   
					neighborsPositions.push_back(neighborCoordinates);
				}//---end for j----------------   
        
				//reset the position values
				neighborCoordinates.clear();
				neighborCoordinates = position;
        
				//make a number of neigbor in the other direccion
				//this number depends on the size of the class
				for(int j = 0; j < size; ++j ){
					neighborCoordinates[i] = neighborCoordinates[i] - 1;   
					neighborsPositions.push_back(neighborCoordinates);
				}//---end for j----------------
         
				//reset the values
				neighborCoordinates.clear();
				neighborCoordinates = position;
    
			}// end i for ----   
    
		}//----calculateNeighborhood(const vector<int> &position)----
     
};
#endif
